// ==UserScript==
// @name        SEO for Opera
// @version     1.0
// @date        2008-09-02
// @author      Janis Elsts <whiteshadow@w-shadow.com>
// @exclude     file://*
// @exclude     ftp://*
// ==/UserScript==
//
// An Opera port of the "SEO for Firefox" Addon by Aaron Wall (http://tools.seobook.com/firefox/seo-for-firefox.html)
// 

//var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var prefManager = new Object();

prefManager.prefs = new Array();

prefManager.prefNames = ["s4f.enabled",	"s4f.highlight",	"s4f.highlightColor",
's4f.pagerank','s4f.pagerank.delay','s4f.cachedate',
's4f.cachedate.delay','s4f.age','s4f.age.delay',
's4f.technorati','s4f.technorati.delay',	's4f.delicious',
's4f.delicious.delay','s4f.alexa','s4f.alexa.delay',
's4f.cached','s4f.cached.delay','s4f.modified',
's4f.modified.delay','s4f.domainmodified','s4f.domainmodified.delay',
's4f.dmoz','s4f.dmoz.delay','s4f.yahoodir','s4f.yahoodir.delay',
's4f.botwdir','s4f.botwdir.delay','s4f.bloglines','s4f.bloglines.delay',
's4f.yahoodomainlinks','s4f.yahoodomainlinks.delay','s4f.msndomainlinks',
's4f.msndomainlinks.delay','s4f.yahooedulinks','s4f.yahooedulinks.delay',
's4f.msnedulinks','s4f.msnedulinks.delay','s4f.yahoogovlinks',
's4f.yahoogovlinks.delay','s4f.msngovlinks','s4f.msngovlinks.delay',
's4f.yahoopagelinks','s4f.yahoopagelinks.delay','s4f.msnpagelinks',
's4f.msnpagelinks.delay','s4f.yahooedupagelinks','s4f.yahooedupagelinks.delay',
's4f.msnedupagelinks','s4f.msnedupagelinks.delay','s4f.wikipedia',
's4f.wikipedia.delay','s4f.competeranking','s4f.competeranking.delay',
's4f.competecount','s4f.competecount.delay',"s4f.whois","s4f.trends"];

prefManager.setPref = function (prefName, prefValue){
	this.prefs[prefName] = prefValue;
}

prefManager.setUpDefaults = function() {
	this.setPref("s4f.enabled",true);
	
	this.setPref("s4f.highlight",false);
	this.setPref("s4f.highlightColor",'#FF0000');
	
	this.setPref('s4f.pagerank','ondemand');
	this.setPref('s4f.pagerank.delay',1);
	this.setPref('s4f.cachedate','hidden');
	this.setPref('s4f.cachedate.delay',1);
	this.setPref('s4f.age','ondemand');
	this.setPref('s4f.age.delay',1);
	this.setPref('s4f.technorati','ondemand');
	this.setPref('s4f.technorati.delay',1);
	this.setPref('s4f.delicious','hidden');
	this.setPref('s4f.delicious.delay',1);
	this.setPref('s4f.alexa','ondemand');
	this.setPref('s4f.alexa.delay',1);
	this.setPref('s4f.cached','ondemand');
	this.setPref('s4f.cached.delay',1);
	this.setPref('s4f.modified','ondemand');
	this.setPref('s4f.modified.delay',1);
	this.setPref('s4f.domainmodified','ondemand');
	this.setPref('s4f.domainmodified.delay',1);
	this.setPref('s4f.dmoz','ondemand');
	this.setPref('s4f.dmoz.delay',1);
	this.setPref('s4f.yahoodir','ondemand');
	this.setPref('s4f.yahoodir.delay',1);
	this.setPref('s4f.botwdir','hidden');
	this.setPref('s4f.botwdir.delay',1);
	this.setPref('s4f.bloglines','ondemand');
	this.setPref('s4f.bloglines.delay',1);
	this.setPref('s4f.yahoodomainlinks','ondemand');
	this.setPref('s4f.yahoodomainlinks.delay',1);
	this.setPref('s4f.msndomainlinks','ondemand');
	this.setPref('s4f.msndomainlinks.delay',1);
	this.setPref('s4f.yahooedulinks','ondemand');
	this.setPref('s4f.yahooedulinks.delay',1);
	this.setPref('s4f.msnedulinks','ondemand');
	this.setPref('s4f.msnedulinks.delay',1);
	this.setPref('s4f.yahoogovlinks','ondemand');
	this.setPref('s4f.yahoogovlinks.delay',1);
	this.setPref('s4f.msngovlinks','ondemand');
	this.setPref('s4f.msngovlinks.delay',1);
	this.setPref('s4f.yahoopagelinks','ondemand');
	this.setPref('s4f.yahoopagelinks.delay',1);
	this.setPref('s4f.msnpagelinks','ondemand');
	this.setPref('s4f.msnpagelinks.delay',1);
	this.setPref('s4f.yahooedupagelinks','ondemand');
	this.setPref('s4f.yahooedupagelinks.delay',1);
	this.setPref('s4f.msnedupagelinks','ondemand');
	this.setPref('s4f.msnedupagelinks.delay',1);
	this.setPref('s4f.wikipedia','hidden');
	this.setPref('s4f.wikipedia.delay',1);
	this.setPref('s4f.competeranking','ondemand');
	this.setPref('s4f.competeranking.delay',1);
	this.setPref('s4f.competecount','ondemand');
	this.setPref('s4f.competecount.delay',1);
	
	this.setPref("s4f.whois","show");
	this.setPref("s4f.trends","show");
}

prefManager.getPref = function(aPrefType, aPrefString, aDefaultValue){
	//aPrefString = str_replace( "extensions.", "", aPrefString );getPref
	aPrefString = aPrefString.replace("extensions.", "");
	try {
	  switch(aPrefType) {
	    case "bool":
	   	  if( ( 'boolean' == typeof this.prefs[aPrefString] ) ) {
			return this.prefs[aPrefString];
		  } else if ( this.prefs[aPrefString]=='true' ) {
			return true;
		  } else if ( this.prefs[aPrefString]=='false' ) {
		  	return false;
		  }
		  return aDefaultValue;
	    case "int":
	      return parseInt( this.prefs[aPrefString] );
	    case "localizedstring":
	    case "color":
	    case "string":
	    default:
	      return this.prefs[aPrefString];
	  }
	} catch(e) {
	  return aDefaultValue;
	}
}

prefManager.getCharPref = function(aPrefString){
	return this.getPref('string', aPrefString, '');
}

prefManager.getBoolPref = function(aPrefString){
	return this.getPref('bool', aPrefString, false);
}

prefManager.getIntPref = function(aPrefString){
	return this.getPref('int', aPrefString, 0);
}

// Initialize the preference storage engine
prefManager.receiveData = function (data, id){
	//alert('receiveData : id = '+id+', data = '+data);
	if (id == 'seo_for_firefox_prefs'){
		//Decode the preference string
		if (data != null) {
			prefArr = data.split('\n');
			for (i=0; i<prefArr.length; i++) {
				prefManager.setPref(prefManager.prefNames[i], prefArr[i]);
			}
			if (prefManager.onPrefsLoaded){
				prefManager.onPrefsLoaded();
			}
		}
	}
}

prefManager.savePreferences = function(){
	//alert('prefManager.savePreferences called');
	//Build the pref. string
	var prefArr = [];
	for (i=0; i<this.prefNames.length; i++) {
		prefArr[i] = this.prefs[this.prefNames[i]];
	}
	this.storage.saveData(prefArr.join('\n'), 'seo_for_firefox_prefs');
}

prefManager.loadPreferences = function(){
	//alert('prefManager.loadPreferences called');
	this.storage.loadData('seo_for_firefox_prefs', 'seo_for_firefox_prefs');
}

prefManager.storage = new s4f_StorageEngine('Seo4Opera',
											'example.com',
											prefManager.receiveData);

prefManager.setUpDefaults();

document.addEventListener('message', function(e){
	if(prefManager.storage.processMessage(e))
	   	return;
}, false);


// ------------------------------------------------------------------------------------------------
// Author: Mike Thomas
// For: SEOBook.com / Aaron Wall
// ------------------------------------------------------------------------------------------------

// ------------------------------------------------------------------------------------------------
// Main functions
// ------------------------------------------------------------------------------------------------

var Seo4Firefox = new Object();
var s = Seo4Firefox;
s.infoGrabbers = new Array();
s.data = new Array();

// Prototype for the dataGrabber
function dataGrabber(name, label, description) {
  this.label = label;
  this.name = name;
  this.description = description;
  this.index = 0;
  this.mode = 'normal';
  this.processor = 'http';
  this.numeric = true;
}
var d = dataGrabber.prototype;

// Query for the given search result index, or the current index
d.get = function() {

  if (this.mode == 'normal') {
    if (typeof arguments[1] != 'undefined') this.index = arguments[1];
    if (!Seo4Firefox.resultUrls[this.index]) {
      if (arguments[2]) {
        this.page = arguments[2];
      }
      else {
          return;
      }
    }
    else {
      this.page = Seo4Firefox.resultUrls[this.index];    
    }  
  }
    
  if (this.processor == 'http') {
        
    var url = this.getUrl(this.page);
    //alert('GET '+url);
    this.xmlHttp = new opera.XMLHttpRequest(true);
    this.xmlHttp.open("GET", url, true);
    this.xmlHttp.onreadystatechange = Delegate.create(this,this.processHTTP);
    this.xmlHttp.send(null);

  }
  
}

// Take the result and display it. Go on to next one if in auto.
d.process = function () {
  if (this.mode == 'single') {
    this.listcell.setAttribute('label',this.result);
  } else if (this.mode == 'normal') {    

    var theDiv = s.doc.getElementById('s4f-' + this.name + '-' + this.index);

    if (theDiv) {
      theDiv.innerHTML = this.getResultHTML(this.result);
    }
    else {
      var tmp = content.document.getElementById('s4f-' + this.name + '-' + this.index);
      if (tmp)
        tmp.innerHTML = this.getResultHTML(this.result);
    }
    Seo4Firefox.data[this.index][this.name] = this.result;
    var mode = prefManager.getCharPref("extensions.s4f." + this.name);
    if (mode == 'auto') {
      this.index++;
      var delay = prefManager.getIntPref("extensions.s4f." + this.name + ".delay");
      window.setTimeout(Delegate.create(this, this.get), delay * 1000);
    }
  }
}

// Take the response from the server, parse it, clean it, and send it to be processed
d.processHTTP = function () {
  if (this.xmlHttp.readyState == 4) {
    if (this.xmlHttp.status == 200) {
      this.result = this.parseResponse(this.xmlHttp.responseText);
      if (this.numeric) {
        this.result = this.getCleanNumber(this.result);
      }
    } else {
      this.result = '-';
    }
    this.process();
  }
}

// Extract and format a number from the result.
d.getCleanNumber = function(number) {
  number = '' + number;
  try
  {
    if (number != '-')
    {
      // Trim
      number = number.replace(/^\s*|\s*$/g,"");
      // Remove commas
      number = number.replace(/,/g,"");
      // Parse integer
      number = parseInt(number);
      // Format
      number = this.addCommas(number);
    }
  }
  catch (e)
  {
    // Anything goes wrong, return a dash
    number = '-';
  }
  return number;
}

// Format a number with commas
d.addCommas = function(nStr) {
  nStr += '';
  var x = nStr.split('.');
  var x1 = x[0];
  var x2 = x.length > 1 ? '.' + x[1] : '';
  var rgx = /(\d+)(\d{3})/;
  while (rgx.test(x1)) {
    x1 = x1.replace(rgx, '$1' + ',' + '$2');
  }
  return x1 + x2;
}

// Put together the HTML that will actually be displayed when the result is received
d.getResultHTML = function(result) {
  var url = this.getInfoUrl(s.resultUrls[this.index]);
  if (url) {
    var resultHTML = ' <a href="' + url + '" target="_blank" title="' + this.description + '">' + this.label + '</a>: ' + result;
  } else {
    var resultHTML = this.label + ': ' + result;
  }
  return resultHTML;
}

// Standard function for parsing Yahoo results (now only used for directory)
d.processYahoo = function(response) {
  if (response.indexOf('We did not find results') == -1) {
    var pieces = response.split('<h1>Search Results</h1>');
    if (pieces.length == 1) {
      pieces = response.split('<h1>Directory Results</h1>');
    }
    if (pieces.length > 1) {
      var pieces = pieces[1].split(' of about ');
      if (pieces.length > 1) {
        pieces = pieces[1].split(' ');
        return pieces[0];
      }
    }
  } else {
    return '0';
  }
  return '-';
}

// Standard function for parsing Yahoo api results
d.processYahooXML = function(response) {
  var pieces = response.split('totalResultsAvailable="');
  if (pieces.length > 1) {
    var pieces = pieces[1].split('"');
    return pieces[0];
  }
  return '-';
}

// Process response from Compete API
d.processCompeteRanking = function (response) {
  var ranking = '-';
  try {
    var parser = new DOMParser();
    var doc = parser.parseFromString(response, 'text/xml');
    ranking = d.getCleanNumber(doc.documentElement.getElementsByTagName('ranking')[0].childNodes[0].nodeValue);
  } catch (e) {}
  return ranking;
}

// Process response from Compete API
d.processCompeteCount = function (response) {
  var count = '-';
  try {
    var parser = new DOMParser();
    var doc = parser.parseFromString(response, 'text/xml');
    count = d.getCleanNumber(doc.documentElement.getElementsByTagName('count')[0].childNodes[0].nodeValue);
  } catch (e) {}
  return count;
}

// ------------------------------------------------------------------------------------------------
// Get Google PageRank
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('pagerank', 'PR', 'Google PageRank for this page');
g.getUrl = function(page) {
  var checksum = "8" + this.getHash(page);
  return "http://www.google.com/search?client=navclient-auto&ch=" + checksum + "&features=Rank&q=info:" + page;
}
g.getInfoUrl = function() { }
g.parseResponse = function(response) {  
  var temp = response.split(':');
  if (typeof parseInt(temp[2]) == 'number') {
    if (isNaN(parseInt(temp[2]))) return "-";
    return temp[2];
  }
  return '-';
}
g.getHash = function(value) {
  var combination = 16909125;
  var seed = "Mining PageRank is AGAINST GOOGLE'S TERMS OF SERVICE. Yes, I'm talking to you, scammer.";
  var doIcare = 'no';
  for(var i = 0; i < value.length; i++ ) {
    combination ^= seed.charCodeAt(i % seed.length) ^ value.charCodeAt(i);
    combination = combination >>> 23 | combination << 9;
  }
  return this.hexEncodeU32(combination);
}
g.hexEncodeU32 = function(num) {
  var result = this.toHex8(num >>> 24);
  result += this.toHex8(num >>> 16 & 255);
  result += this.toHex8(num >>> 8 & 255);
  return result + this.toHex8(num & 255);
}
g.toHex8 = function(num) {
  return(num < 16 ? "0" : "") + num.toString(16);
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get Google cache date
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('cachedate', 'Google Cache Date','The date Google last cached this page.');
g.numeric = false;

g.getUrl = function(page) {
  return "http://www.google.com/search?q=cache%3A" + page;
}

g.getInfoUrl = function(page) { return this.getUrl(page); }

g.parseResponse = function(response) {  
  var pieces = response.split('as it appeared on ');
  if (pieces.length == 2) {
    pieces = pieces[1].split(' ');
    var day = pieces[0];
    var year = pieces[2];
    var month = pieces[1];
    return month + ' ' + day + ' ' + year;
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get age from Archive.org
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('age', 'Age','First record of this page on archive.org');
g.numeric = false;

g.getUrl = function(page) {
  var domain = s.getDomain(page);
  return "http://web.archive.org/web/*/" + domain;
}

g.getInfoUrl = function(page) { return this.getUrl(page); }

g.parseResponse = function(response) {
  var pieces = response.split('href="http://web.archive.org/web/');
  if (pieces.length > 2) {
    pieces = pieces[2].split('/');
    var year = pieces[0].substr(0,4);
    var month = pieces[0].substr(4,2);
    return month + '-' + year;
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get citations from del.icio.us
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('delicious', 'del.icio.us','Number of people who have bookmarked this site on del.icio.us');
g.getUrl = function(page) {
  //del.icio.us redirects to delicious.com and redirects cause a security violation 
  //in the cross-domain XmlHttpRequest hack. Therefore, use delicious.com here. 
  return "http://delicious.com/url/check?url=" + s.getDomain(page) + "&submit=check%20url";
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('There is no del.icio.us history for this url') == -1) {
    
    var pieces = response.split('People have saved this <span class="saver');
    if (pieces.length > 1) {
      pieces = pieces[1].split('>');
      if (pieces.length > 1) {
          pieces = pieces[1].split('<');
          return pieces[0];
      }
    }
    
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get domain links from Yahoo!
// ------------------------------------------------------------------------------------------------

var baseurl = 'http://api.search.yahoo.com/WebSearchService/V1/webSearch?results=1&appid=seo4firefox&adult_ok=1&query=';

var g = new dataGrabber('yahoodomainlinks', 'Y! Links','Pages linking to this domain on Yahoo!');
g.getUrl = function(page) {
  return baseurl + "linkdomain:" + s.getDomain(page) + ' -site:' + s.getDomain(page);
}
g.getInfoUrl = function(page) {
  return "http://search.yahoo.com/search?p=linkdomain:" + s.getDomain(page) + ' -site:' + s.getDomain(page);
}
g.parseResponse = function(response) { return this.processYahooXML(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get .edu links from Yahoo!
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('yahooedulinks', 'Y! .edu Links','Pages linking to this domain on Yahoo! from .edu domains');
g.getUrl = function(page) {
  return baseurl + "linkdomain:" + s.getDomain(page) + ' -site:' + s.getDomain(page) + ' site:.edu';
}
g.getInfoUrl = function(page) {
  return "http://search.yahoo.com/search?p=linkdomain:" + s.getDomain(page) + " %2Bsite:.edu -site:.com -site:" + s.getDomain(page);
}
g.parseResponse = function(response) { return this.processYahooXML(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get .gov links from Yahoo!
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('yahoogovlinks', 'Y! .gov Links','Pages linking to this domain on Yahoo! from .gov domains');
g.getUrl = function(page) {
  return baseurl + "linkdomain:" + s.getDomain(page) + ' -site:' + s.getDomain(page) + ' site:.gov';
}
g.getInfoUrl = function(page) {
  return "http://search.yahoo.com/search?p=linkdomain:" + s.getDomain(page) + " %2Bsite:.gov -site:.com -site:" + s.getDomain(page);
}
g.parseResponse = function(response) { return this.processYahooXML(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get page links from Yahoo!
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('yahoopagelinks', 'Y! Page Links','Pages linking to this page on Yahoo!');
g.getUrl = function(page) {
  return baseurl + "link:http://" + page + ' -site:' + s.getDomain(page);
}
g.getInfoUrl = function(page) {
  return "http://search.yahoo.com/search?p=link:http://" + page + ' -site:' + s.getDomain(page);
}
g.parseResponse = function(response) { return this.processYahooXML(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get .edu page links from Yahoo!
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('yahooedupagelinks', 'Y! .edu Page Links','Pages linking to this page on Yahoo! from .edu domains');
g.getUrl = function(page) {
  return baseurl + "link:http://" + page + ' -site:' + s.getDomain(page) + ' site:.edu';
}
g.getInfoUrl = function(page) {
  return "http://search.yahoo.com/search?p=link:http://" + page + " %2Bsite:.edu -site:.com -site:" + s.getDomain(page);
}
g.parseResponse = function(response) { return this.processYahooXML(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get Technorati citations
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('technorati', 'Technorati','Citations for this domain on Technorati');
g.getUrl = function(page) {
  return 'http://api.technorati.com/cosmos?key=43098cee86597c365bee22cd9179f2c8&url=' + s.getDomain(page) + '&limit=1';
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('<inboundlinks/>') == -1) {
    var pieces = response.split('<inboundlinks>');
    if (pieces.length > 1) {
      var pieces = pieces[1].split('</inboundlinks>');
      if (pieces.length > 1) {
        return pieces[0];    // Trim
      }
    }
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get Alexa Ranking
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('alexa', 'Alexa','Alexa Traffic Rank');
g.getUrl = function(page) {
  return "http://data.alexa.com/data?cli=10&dat=s&url=" + s.getDomain(page);
}
g.getInfoUrl = function(page) { return "http://www.alexa.com/data/details/main?q=" + s.getDomain(page) + "&url=" + s.getDomain(page); }
g.parseResponse = function(response) {
  if (response.indexOf('<POPULARITY') != -1) {
    if (/<POPULARITY URL="(.*?)" TEXT="(\d+)"\/>/i.test(response)) {
        p = /<POPULARITY URL="(.*?)" TEXT="(\d+)"\/>/i.exec(response);
        return p[2];
    }
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get ranking from Compete.com
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('competeranking', 'Compete.com Rank', 'Rank on Compete.com');
g.getUrl = function(page) {
  return 'http://api.compete.com/fast-cgi/MI?d=' + s.getDomain(page) + '&ver=3&apikey=aby5srp7nmkb78q44m5ftbm3';
}
g.getInfoUrl = function(page) {
  return 'http://siteanalytics.compete.com/' + s.getDomain(page) + '/?metric=uv';
}
g.parseResponse = function(response) { return this.processCompeteRanking(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get count from Compete.com
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('competecount', 'Compete.com Uniques', 'Uniques on Compete.com');
g.getUrl = function(page) {
  return 'http://api.compete.com/fast-cgi/MI?d=' +s.getDomain(page) + '&ver=3&apikey=aby5srp7nmkb78q44m5ftbm3';
}
g.getInfoUrl = function(page) {
  return 'http://siteanalytics.compete.com/' + s.getDomain(page) + '/?metric=uv';
}
g.parseResponse = function(response) { return this.processCompeteCount(response); }
s.infoGrabbers.push(g);

var g = new dataGrabber('trends', 'Trends', 'Google trends for this domain');
g.getInfoUrl = function(page) {
  return 'http://trends.google.com/websites?q=' + s.getDomain(page) + '&geo=all&date=all';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get number of pages cached by google
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('cached', 'Cached','Number of pages from this domain cached by google');
g.getUrl = function(page) {
  return "http://www.google.com/search?q=site%3A" + s.getDomain(page);
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('did not match any documents') == -1) {
    if (response.indexOf('</b> of <b>') != -1) { var pieces = response.split('</b> of <b>'); }
    else { var pieces = response.split('</b> of about <b>'); }
    if (pieces.length > 1) {
      pieces = pieces[1].split('from');
      pieces = pieces[0].replace(/<(.|\n)+?>/g, "");
      return pieces;
    }
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get date the page was last modified
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('modified', 'Page Modified','The last time this page was modified');

g.get = function() {
  this.fullheader = '';
  if (this.mode == 'normal') {
    if (typeof arguments[1] != 'undefined') this.index = arguments[1];
    if (!s.resultUrls[this.index]) return;
    this.page = s.resultUrls[this.index];
  }
  try {
    var uri=Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uri.spec = 'http://' + this.page;
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    this.channel = ioService.newChannelFromURI(uri).QueryInterface(Components.interfaces.nsIHttpChannel);
    this.channel.requestMethod = "HEAD";
    this.channel.loadFlags |=  1 | 128;
    this.channel.asyncOpen(this,null);
  } catch(e) {  }
}
g.onDataAvailable = function (request, ctxt, input, offset, count) {  }
g.onStartRequest = function (request, ctxt) {
  request.QueryInterface(Components.interfaces.nsIHttpChannel);
  try {
    var response = request.getResponseHeader('last-modified');
  } catch (e) {
    var response = '-';
  }
  this.result = this.parseResponse(response);
  this.process();
}
g.onStopRequest = function (request, ctxt, status) { }
g.getInfoUrl = function(page) { return ''; }
g.parseResponse = function(response) {
  if (response == '-') return response;
  var pieces = response.split(' ');
  return pieces[1] + ' ' + pieces[2] + ' ' + pieces[3];
}
try { if (prefManager.getBoolPref("extensions.s4f.aaron")) { s.infoGrabbers.push(g); } } catch (e) { }

// ------------------------------------------------------------------------------------------------
// Get date the domain was last modified
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('domainmodified', 'Domain Modified', 'The last time this domain was modified');

g.get = function() {
  this.fullheader = '';
  if (this.mode == 'normal') {
    if (typeof arguments[1] != 'undefined') this.index = arguments[1];
    if (!s.resultUrls[this.index]) return;
    this.page = s.resultUrls[this.index];
  }
  try {
    var uri=Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uri.spec = 'http://' + s.getDomain(this.page);
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    this.channel = ioService.newChannelFromURI(uri).QueryInterface(Components.interfaces.nsIHttpChannel);
    this.channel.requestMethod = "HEAD";
    this.channel.loadFlags |=  1 | 128;
    this.channel.asyncOpen(this,null);
  } catch(e) {  }
}
g.onDataAvailable = function (request, ctxt, input, offset, count) {  }
g.onStartRequest = function (request, ctxt) {
  request.QueryInterface(Components.interfaces.nsIHttpChannel);
  try {
    var response = request.getResponseHeader('last-modified');
  } catch (e) {
    var response = '-';
  }
  this.result = this.parseResponse(response);
  this.process();
}
g.onStopRequest = function (request, ctxt, status) { }
g.getInfoUrl = function(page) { return ''; }
g.parseResponse = function(response) {
  if (response == '-') return response;
  var pieces = response.split(' ');
  return pieces[1] + ' ' + pieces[2] + ' ' + pieces[3];
}
try { if (prefManager.getBoolPref("extensions.s4f.aaron")) { s.infoGrabbers.push(g); } } catch (e) { }

// ------------------------------------------------------------------------------------------------
// Get listings in dmoz.org
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('dmoz', 'dmoz','Entries for this domain on dmoz.org');
g.getUrl = function(page) {
  return "http://www.google.com/search?q=" + s.getDomain(page) + "&cat=gwd%2FTop";
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('did not match any documents') == -1) {
    if (response.indexOf('</b> of <b>') != -1) { var pieces = response.split('</b> of <b>'); }
    else { var pieces = response.split('</b> of about <b>'); }
    if (pieces.length > 1) {
      pieces = pieces[1].split('for');
      pieces = pieces[0].replace(/<(.|\n)+?>/g, "");
      return pieces;
    }
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get bloglines subscribers
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('bloglines', 'Bloglines','Number of people subscribed to this sites rss feed on bloglines.com');
g.getUrl = function(page) {
  return "http://www.bloglines.com/search?q=" + s.getDomain(page) + "&t=f";
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('did not match with any results') == -1) {
    var pieces = response.split('<span class="blog-subs">(');
    if (pieces.length > 1) {
      pieces = pieces[1].split('</a>');
      pieces = pieces[0].replace(/<(.|\n)+?>/g, "");
      pieces = pieces.replace(/subscribers/g, "");
      return pieces;
    }
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get wikipedia pages that link to the domain
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('wikipedia', 'wikipedia','Number of articles that link to this domain on wikipedia.org');
g.getUrl = function(page) {
  return "http://en.wikipedia.org/wiki/Special:Search?search=*" + s.getDomain(page).replace(/^www\./i,'') + "&go=Go";
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) {
  if (response.indexOf('No results found.') == -1) {
    
  var pieces = response.split('results <b>1 -');
    if (pieces.length > 1) {
      pieces = pieces[1].split('<b>');
      pieces = pieces[1].split('</b>');      
      pieces = pieces[0];
      return pieces;
    }
  } else {
    return '0';
  }
  return '-';
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get listings in dir.yahoo.com
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('yahoodir', 'dir.yahoo.com','Number of entries for this site in the Yahoo! directory');
g.getUrl = function(page) {
  return "http://search.yahoo.com/search/dir?h=c&p=" + s.getDomain(page);
}
g.getInfoUrl = function(page) { return this.getUrl(page) }
g.parseResponse = function(response) { return this.processYahoo(response); }
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Get listings in BOTW
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('botwdir', 'Botw', 'Number of entries for this site in the BOTW directory');
g.getUrl = function(page) {
  return "http://botw.org/opensearchrss.aspx?q=" + s.getDomain(page).replace(/^www\./i,'');
}
g.getInfoUrl = function(page) {
  return "http://botw.org/nsearch/" + s.getDomain(page).replace(/^www\./i,'');
}

g.parseResponse = function(response) {
  return /<openSearch:totalResults>(\d+)<\/openSearch:totalResults>/.exec(response)[1];
}

s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// Show Whois Link
// ------------------------------------------------------------------------------------------------

var g = new dataGrabber('whois', 'Whois', 'Whois information for this domain');
g.getInfoUrl = function(page) {
  return 'http://whois.domaintools.com/' + s.getDomain(page);
}
s.infoGrabbers.push(g);

// ------------------------------------------------------------------------------------------------
// If they right click on a link, show the link option in the menu
// ------------------------------------------------------------------------------------------------

s.contextPopupShowing = function () {
  var menuitem = document.getElementById('s4f-linkpopup');
  if (menuitem && gContextMenu.linkURL) {
    menuitem.hidden = false;
  } else {
    menuitem.hidden = true;
  }
}

s.getSortableDate = function (dateString, mode) {
  var months = {'Jan':'01','Feb':'02','Mar':'03','Apr':'04','May':'05','Jun':'06','Jul':'07','Aug':'08','Sep':'09','Oct':'10','Nov':'11','Dec':'12'};
  if (mode == 'cachedate') {
    var pieces = dateString.split(' ');
    if (pieces.length < 3) return -1;
    pieces[0] = months[pieces[0]];
    pieces[1] = (pieces[1].length == 1) ? '0' + pieces[1] : pieces[1];
    var result = parseInt(pieces[2] + pieces[0] + pieces[1]);
  } else if (mode == 'age') {
    var pieces = dateString.split('-');
    var result = parseInt(pieces[1] + pieces[0]);
  }
  return result;
}

/*
  Sort the elements on the search page in order of some selected parameter that we have fetched. My
  basic strategy here is to get the parameter of interest in a tuple (Array) with the pointer to the
  actual html element. We'll have a sort function that just sorts on the first element of the tuple
  and when we're done we'll have the order for our elements. At any point s.data contains all data
  and pointers to the html elements in the original order.

  The sorting will be purely numeric and is a one-time sort, so new values coming in will be ignored
  until the next sort and unset values (i.e. '?') will not be sorted.
*/
s.sortResults = function (grabber) {
  var parent = s.data[0]['element'].parentNode;
  
  if (grabber == 'nothing') {
    for (var i = 0; i < s.data.length; i++) {
      parent.appendChild(s.data[i]['element']);
    }
    return;
  }
  var sorted = new Array();
  for (var i = 0; i < s.data.length; i++) {
    if ((grabber == 'cachedate') || (grabber == 'age')) {
      var value = s.getSortableDate(s.data[i][grabber], grabber);
    } else {
      var value = parseInt(s.data[i][grabber].replace(/,/g,''));
    }
    if (isNaN(value)) value = -1;
    var tuple = [value,s.data[i]['element']];
    sorted.push(tuple);
  }
  
  if ((grabber == 'competeranking') || (grabber == 'alexa')) {
    sorted.sort(s.sortInverseFunction); 
  }
  else {
    sorted.sort(s.sortFunction); 
  }
  
  for (var i = 0; i < sorted.length; i++) {
    parent.appendChild(sorted[i][1]);
  }
}

s.sortFunction = function (a, b) {
  return b[0] - a[0];
}

s.sortInverseFunction = function (a, b) {
  return a[0] - b[0];
}

// ------------------------------------------------------------------------------------------------
// The main load routine
// ------------------------------------------------------------------------------------------------

s.checkLoad = function(e) {
  
  //if (!(e.originalTarget instanceof HTMLDocument)) return;
  //if (e.originalTarget.defaultView.frameElement) return; 
  /*
  if (document.getElementById("contentAreaContextMenu"))
  {
      document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", s.contextPopupShowing, false);      
  }
  */

  //alert('Checkload running');

  this.updateStatus();

  if (!prefManager.getBoolPref("extensions.s4f.enabled")) {
	//alert('S4O not enabled!');
	return;
  }

  //alert('It appears I am enabled!');

  //s.doc = e.originalTarget;
  this.doc = window.document;

  if (prefManager.getBoolPref("extensions.s4f.highlight")) {
    var globalNoFollow = false;
    
    var hHead = this.doc.getElementsByTagName("head")[0];

    for (var ii in hHead.childNodes) {
      var meta = hHead.childNodes[ii];
      if (meta && meta.name && meta.name.match(/\brobots\b/i)) {
        if (meta.content && meta.content.match(/\bnofollow\b/i)) { globalNoFollow = true; }
      }
    }
    
    var body = this.doc.getElementsByTagName("body")[0];
    var nofollows = this.doc.links; //body.getElementsByTagName('a');
    
    for (var i = 0; i < nofollows.length; i++) {
      var nofollow = nofollows[i];

      if (globalNoFollow || (nofollow.rel && nofollow.rel.match(/\bnofollow\b/i))) {
        nofollow.style.backgroundColor = prefManager.getCharPref("extensions.s4f.highlightColor");
    
      }
    }
  }
  
  
  var loc = this.doc.location;
    
  try {
        
    this.resultElements = new Array();    
    s.resultUrls     = new Array();    
    startC           = 0;
        
    // Get Google search results
    if (loc && loc.href && loc.href.match( /^http:\/\/(www\.)?google\.[a-z]{2,3}(\.[a-z]{2,3})?\/search\?.*/i ) ){
            
      if (/(\d+) - (\d+) of about (\d+)/i.test(s.doc.body.textContent)) {
        p = /(\d+) - (\d+) of about (\d+)/i.exec(s.doc.body.textContent);
        startC = p[1] - 1;
      }

      this.bgcolor = '#e5ecf9';
      var results = s.doc.getElementsByTagName('li');      
      
      for (var i in results) {
        var result = results[i];
        if (result.className == 'g') {
          var innerLinks = result.getElementsByTagName('a');
          var url = innerLinks[0].href;
          url = url.replace('http://','');
          url = url.replace('https://','');
          s.resultElements.push(result);
          s.resultUrls.push(url);
        }
      }

      results = s.doc.getElementsByTagName('div');      
      
      for (var i in results) {
        var result = results[i];
        if (result.className == 'g') {
          var innerLinks = result.getElementsByTagName('a');
          var url = innerLinks[0].href;
          url = url.replace('http://','');
          url = url.replace('https://','');
          s.resultElements.push(result);
          s.resultUrls.push(url);
        }
      }

      var temp = s.doc.getElementsByTagName('input');
      temp = temp[0];
      var maxTries = 0;
      while ((maxTries < 5) && (temp.tagName != 'TBODY')) {
        temp = temp.parentNode;
        maxTries++;
      }
      if (maxTries > 5) return;
      var appendTo = temp;

      var container = s.doc.createElement('tr');
      temp = s.doc.getElementsByName('q');
      var inputBox = temp[0];
      var searchString = inputBox.value;
      s.showKeywordLinks(appendTo,container,searchString);
    }
    // Get Yahoo! search results
    else if (loc && loc.href && loc.href.match( /^http:\/\/(.*\.)?search\.yahoo\.(com|co\.jp)\/search.*/i ) && !loc.href.match( /^http:\/\/(.*\.)?search\.yahoo\.(com|co\.jp)\/search\/dir/i )) { // loc.href.match(/search\.htm/)) { //
      if (/(\d+) - (\d+) of about (\d+)/i.test(s.doc.body.textContent)) {
        p = /(\d+) - (\d+) of about (\d+)/i.exec(s.doc.body.textContent);
        startC = p[1] - 1;
      }
            
      this.bgcolor = '#ecf5fa';
      var ol = s.doc.getElementsByTagName('ol');
      ol = ol[0];
            
      var results = ol.getElementsByTagName('li');
      for (var i = 0; i < results.length; i++) {
        var result = results[i];
                
        var rawurl = '';
        
        try {
           rawurl = result.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[0].href;
        }
        catch (e) {
          
        }
        
        if (!rawurl) {
        
          try {
            rawurl = result.childNodes[0].childNodes[0].childNodes[0].href;
          }
          catch(e) {
            
          }
        }
        
        if (!rawurl) {
          
          try {
            rawurl = result.childNodes[0].childNodes[0].childNodes[0].childNodes[0].href;
          }
          catch(e) {
            
          }
          
        }
        
        if (rawurl) {
          
          var japan = false;
          var pieces = rawurl.split('**');
          if (!pieces[1]) {
            pieces = rawurl.split('*-');
            japan = true;
          }
          
          if (!pieces[1] && !rawurl.match(/yahoo.com/)) {
            pieces = [];
            pieces[0] = rawurl;
            pieces[1] = rawurl;
          }
          
          if (pieces[1]) {
            var url = pieces[1];
            url = url.replace('http://','');
            url = url.replace('https://','');
            url = url.replace('http%3a//','');
            url = url.replace('https%3a//','');
            url = url.replace('http%3A//','');
            url = url.replace('https%3A//','');
            
            if (!japan) {
              s.resultElements.push(result.childNodes[0].childNodes[0]);
            }
            else {
              if (pieces[0] == pieces[1]) {
                s.resultElements.push(result.childNodes[0]);  
              }
              else {
                s.resultElements.push(result);  
              }
              
            }
            s.resultUrls.push(url);
          }
        }
        else {

        }
      }      
      
      var appendTo = s.doc.getElementById('sbx');
      if (!appendTo) {
        appendTo = s.doc.getElementById('yschqcon');
      }
      var container = s.doc.createElement('div');
      temp = s.doc.getElementsByName('p');
      var inputBox = temp[0];
      var searchString = inputBox.value;      
      s.showKeywordLinks(appendTo,container,searchString);
    }
    else {
      return;
    }

    // Append seo information to search results
    s.data = new Array()
    if (s.resultElements.length > 0) {
      var count = 0;
      //if (startC) { count = startC; }
      // get real count
      for (var i in s.resultElements) {
        element = s.resultElements[i];
        url = s.resultUrls[i];

        var data = new Object();
        data['url'] = url;
        data['element'] = element;

        var theDiv = s.doc.createElement('div');
        theDiv.style.fontSize = '10px';
        var theContainer = s.doc.createElement('span');
        theContainer.style.backgroundColor = this.bgcolor;
        theContainer.style.padding = '2px';
        theDiv.style.marginTop = '4px';
        var theSpan = s.doc.createElement('span');
        theSpan.style.fontWeight = 'bold';
        theSpan.innerHTML = '#' + (startC + count + 1).toString() + ' | ';
        theContainer.appendChild(theSpan);
        var grabCount = 0;
        for (var i = 0; i < s.infoGrabbers.length; i++) {
          var grabber = s.infoGrabbers[i];
          grabber.index = 0;
          data[grabber.name] = '?';
          var mode = prefManager.getCharPref("extensions.s4f." + grabber.name);
          if (mode == 'auto') {
            if (grabCount > 0) theContainer.appendChild(s.doc.createTextNode(' | '));
            grabCount++;

            // Create a span to contain this grabber
            var theSpan = s.doc.createElement('span');
            theSpan.id = 's4f-' + grabber.name + '-' + count;

            // Create a link to to the page we're grabbing the data from and append it to the span.
            if (grabber.getInfoUrl(url)) {
              var theLink = s.doc.createElement('a');
              theLink.href = grabber.getInfoUrl(url);
              theLink.target = '_blank';
              theLink.title = grabber.description;
              theLink.appendChild(s.doc.createTextNode(grabber.label));
              theSpan.appendChild(theLink);
              theSpan.appendChild(s.doc.createTextNode(': ?'));
            } else {
              theSpan.appendChild(s.doc.createTextNode(grabber.label + ': ?'));
            }

            // Append the span to the div
            theContainer.appendChild(theSpan);
          } else if (mode == 'ondemand') {
            if (grabCount > 0) theContainer.appendChild(s.doc.createTextNode(' | '));
            grabCount++;

            // Create a span to contain this grabber
            var theSpan = s.doc.createElement('span');
            theSpan.id = 's4f-' + grabber.name + '-' + count;

            // Create a link to to the page we're grabbing the data from and append it to the span.
            if (grabber.getInfoUrl(url)) {
              var theLink = s.doc.createElement('a');
              theLink.href = grabber.getInfoUrl(url);
              theLink.target = '_blank';
              theLink.title = grabber.description;
              theLink.appendChild(s.doc.createTextNode(grabber.label));
              theSpan.appendChild(theLink);
              theSpan.appendChild(s.doc.createTextNode(': '));
            } else {
              theSpan.appendChild(s.doc.createTextNode(grabber.label + ': '));
            }

            // Create a link to fetch the data
            var theFetchLink = s.doc.createElement('a');
            theFetchLink.href = 'javascript:{}';
            theFetchLink.title = 'Click Here To Fetch';
            theFetchLink.addEventListener('click', Delegate.create(grabber, grabber.get, count, url), true);
            theFetchLink.appendChild(s.doc.createTextNode('?'));
            theSpan.appendChild(theFetchLink);

            // Append the span to the div.
            theContainer.appendChild(theSpan);
          } else if (mode == 'show') {
            if (grabCount > 0) theContainer.appendChild(s.doc.createTextNode(' | '));
            grabCount++;

            // Create a span to contain this grabber
            var theSpan = s.doc.createElement('span');
            theSpan.id = 's4f-' + grabber.name + '-' + count;

            // Create a link to to the page we're grabbing the data from and append it to the span.
            if (grabber.getInfoUrl(url)) {
              var theLink = s.doc.createElement('a');
              theLink.target = '_blank';
              theLink.href = grabber.getInfoUrl(url);
              theLink.title = grabber.description;
              theLink.appendChild(s.doc.createTextNode(grabber.label));
              theSpan.appendChild(theLink);
            }

            // Append the span to the div.
            theContainer.appendChild(theSpan);
          }
        }
        Seo4Firefox.data.push(data);
        theDiv.appendChild(theContainer);
        element.appendChild(theDiv);
        count++;
      }
      for (var i = 0; i < s.infoGrabbers.length; i++) {
        var grabber = s.infoGrabbers[i];
        var mode = prefManager.getCharPref("extensions.s4f." + grabber.name);
        if (mode == 'auto') {
          var delay = prefManager.getIntPref("extensions.s4f." + grabber.name + ".delay");
          window.setTimeout(Delegate.create(grabber, grabber.get), delay * 1000);
        }
      }
    }
  } catch (e) { s.Log("SEO4FF Internal Error: " + e.message); }
}


// ------------------------------------------------------------------------------------------------
// Generate CSV Output
// ------------------------------------------------------------------------------------------------

s.generateCSV = function() {
  /*
  const nsIFilePicker = Components.interfaces.nsIFilePicker;

  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Output To CSV", nsIFilePicker.modeSave);
  fp.appendFilter("CSV File (*.csv)","*.csv");
  fp.defaultExtension = 'csv';

  var rv = fp.show();
  if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
    file = fp.file;
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

    try {
      foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
      var line = '"URL",';
      for (j = 0; j < this.infoGrabbers.length; j++) {
        line += this.infoGrabbers[j].label + ',';
      }
      line += "\n";
      foStream.write(line, line.length);
      for (i = 0; i < this.data.length; i++) {
        var line = this.data[i].url + ',';
        for (j = 0; j < this.infoGrabbers.length; j++) {
          line += '"' + this.data[i][this.infoGrabbers[j].name] + '",';
        }
        line += "\n";
        foStream.write(line, line.length);
      }
      foStream.close();
    } catch(e) {
      alert('File save error: ' + e.message);
    }
  }
  */
}

// ------------------------------------------------------------------------------------------------
// Show keyword links next to the search box
// ------------------------------------------------------------------------------------------------

s.showKeywordLinks = function(appendTo,container,searchString) {
  container.style.fontSize = '10px';

  // Keyword Research link
  var myLink = s.doc.createElement('a');
  myLink.href = 'http://tools.seobook.com/general/keyword/suggestions/' + searchString.replace(/ /g,'%20') + '#results';
  myLink.target = '_blank';
  myLink.appendChild(s.doc.createTextNode('KW Research'));
  container.appendChild(myLink);
  container.appendChild(s.doc.createTextNode(' | '));

  // AW Sandbox link
  var myLink = s.doc.createElement('a');
  myLink.href = 'https://adwords.google.com/select/KeywordToolExternal';
  myLink.target = '_blank';
  myLink.appendChild(s.doc.createTextNode('AW Sandbox'));
  container.appendChild(myLink);
  container.appendChild(s.doc.createTextNode(' | '));

  // Traffic Estimator link
  var myLink = s.doc.createElement('a'),
      kwd = searchString.replace(/ /g,'%20');
  myLink.href = 'https://adwords.google.com/select/TrafficEstimatorSandbox?save=save&keywords='+ kwd +'%0A%22'+ kwd +'%22%0A['+ kwd +']%0A'+ kwd +'s%0A%22'+ kwd +'s%22%0A['+ kwd +'s]&currency=USD&language=en';
  myLink.target = '_blank';
  myLink.appendChild(s.doc.createTextNode('Traffic Estimator'));
  container.appendChild(myLink);
  container.appendChild(s.doc.createTextNode(' | '));

  // Google Trends link
  var myLink = s.doc.createElement('a');
  myLink.href = 'http://www.google.com/trends?q=' + searchString.replace(/ /g,'+') + '&ctab=0&date=all';
  myLink.target = '_blank';
  myLink.appendChild(s.doc.createTextNode('Trends'));
  container.appendChild(myLink);
  container.appendChild(s.doc.createTextNode(' | '));

  var myUrl = s.doc.URL;
  
  if (myUrl.match( /^http:\/\/(www\.)?google\.[a-z]{2,3}(\.[a-z]{2,3})?\/search\?.*/i )) {
    // 100 Link
    var myLink = s.doc.createElement('a');
    myLink.target = '_blank';
    myLink.href = s.doc.URL+'&num=100&pws=0'; 
    myLink.appendChild(s.doc.createTextNode('100'));
    container.appendChild(myLink);
    container.appendChild(s.doc.createTextNode(' | '));
  }
  else {
    var myLink = s.doc.createElement('a');
    myLink.target = '_blank';
    myLink.href = s.doc.URL+'&n=100'; 
    myLink.appendChild(s.doc.createTextNode('100'));
    container.appendChild(myLink);
    container.appendChild(s.doc.createTextNode(' | '));    
  }

 /*// WSH : Can't generate files in Opera.
  // CSV link
  var myLink = s.doc.createElement('a');
  myLink.href = 'javascript:{}';
  myLink.title = 'Generate CSV File';
  myLink.addEventListener('click', Delegate.create(s, s.generateCSV), true);
  myLink.appendChild(s.doc.createTextNode('CSV'));
  container.appendChild(myLink);
  */
  
  // SEO for Opera options link
  var myLink = s.doc.createElement('a');
  myLink.href = 'javascript:Seo4Firefox.showOptions()';
  myLink.appendChild(s.doc.createTextNode('S4O Preferences'));
  container.appendChild(myLink);

  appendTo.appendChild(container);
}

s.available_grabbers = [
		['s4f.pagerank', 'PageRank'],
		//['s4f.cachedate', 'Google Cache Date'], //Can't use due to redirects
		['s4f.age', 'Age (archive.org)'],
		//['s4f.delicious', 'del.icio.us'], //Causes partial browser freeze
		
		['s4f.yahoodomainlinks','Y! Domain Links'],
		['s4f.yahoopagelinks','Y! Page Links'],
		['s4f.yahooedulinks','Y! .edu Links'],
		['s4f.yahoogovlinks','Y! .gov Links'],
		['s4f.yahooedupagelinks','Y! .edu Page Links'],
		/*
		['s4f.msndomainlinks','MSN Domain Links'],
		['s4f.msnpagelinks','MSN Page Links'],
		['s4f.msnedulinks','MSN .edu links'],
		['s4f.msngovlinks','MSN .gov Links'],
		['s4f.msnedupagelinks','MSN .edu Page Links'],
		*/
		['s4f.technorati', 'Technorati'],
		['s4f.alexa','Alexa'],
		
		['s4f.competeranking','Compete.com Rank'],
		['s4f.competecount','Compete.com Uniques'],
		
		['s4f.cached', 'Cached'],
		['s4f.dmoz', 'DMOZ'],
		['s4f.bloglines','Bloglines Subscribers'],
		['s4f.wikipedia','Wikipedia'],
		['s4f.yahoodir', 'dir.yahoo.com'],
		
		//['s4f.botwdir', 'Botw'] //Problematic : Triggers the RSS subscription dialog (but still works)
	 ];

s.showOptions = function () {
	var panel_width = 400;
	var panel_height = 610;
	
	//Calculate panel position
	var left = (document.documentElement.clientWidth - panel_width)/2;
	
	//Opera handles the below calculation differently in quirks mode vs. normal mode.
	//That's why I calculate it both ways and use the smallest value.
	var top = (document.documentElement.clientHeight - panel_height)/2;
	var top_alt = (document.body.clientHeight - panel_height)/2;
	top = Math.min(top, top_alt);
	
	function make_selector(select_id, options, selected_option){
		var rez='<select id="'+select_id+'">';
		for (j=0; j<options.length; j++){
			rez = rez + '<option value="' + options[j][0] + '"';
			if (options[j][0]==selected_option){
				rez = rez + ' selected="selected"';
			}
			rez = rez + '>'+options[j][1]+'</option>' ; 
		}
		rez = rez + '</select>';
		return rez;
	}
	
	var mode_options = [['hidden', 'Hidden'], ['ondemand','On-Demand'],['auto','Auto']];
	var delay_options = [[0, '0 sec'], [1, '1 sec'], [2, '2 sec'], [3, '3 sec'], [4, '4 sec'], [5, '5 sec']];
	var available_grabbers = this.available_grabbers;
	
	var cnt = '<style>.s4f_td {padding: 3px !important; height: 22px !important; vertical-align: middle;}</style>'+
		'<table cellspacing="0" cellpadding="3" border="0">'+
		'<tr><td colspan="4" align="center" class="s4f_td"><strong>SEO for Opera Preferences</strong></td></tr>'+
		/*	Use the custom button to enable/disable instead of a checkbox here 
		'<tr><td colspan="4"><input type="checkbox" id="s4f.enabled" '+
		(prefManager.getBoolPref('s4f.enabled')?' checked="checked"':'')+'/> '+
		'<label for="s4f.enabled"><strong>Enable SEO for Opera</strong></label></td></tr>'+
		*/
		'<tr><td colspan="4" class="s4f_td"><input type="checkbox" id="s4f.highlight" '+
		(prefManager.getBoolPref('s4f.highlight')?' checked="checked"':'')+'/> '+
		'<label for="s4f.highlight">Highlight Nofollow links</label>'+
		' <input type="text" id="s4f.highlightColor" value="'+
		prefManager.getCharPref('s4f.highlightColor')+'" size="8" /></td></tr>'+
		
		'<tr><td colspan="4"></td></tr>';
				
	for (i = 0; i < available_grabbers.length; i++){
		//alert ('Processing '+available_grabbers[i][1]+' ('+available_grabbers[i][0]+')');
		cnt += '<tr><td class="s4f_td">'+available_grabbers[i][1]+'</td>';
		cnt += '<td class="s4f_td">'+
			   make_selector(
					available_grabbers[i][0], 
					mode_options,
					prefManager.getCharPref(available_grabbers[i][0]))+
				'</td>';
		cnt += '<td class="s4f_td">Delay</td>';
		cnt += '<td class="s4f_td">'+
			   make_selector(
					available_grabbers[i][0]+'.delay', 
					delay_options,
					prefManager.getIntPref(available_grabbers[i][0]+'.delay'))+
				'</td>';
		cnt += '</tr>\n';
	}
	
	cnt += '<tr><td class="s4f_td">Trends</td><td class="s4f_td">'+
			make_selector(
				's4f.trends', 
				[['show', 'Show'], ['hidden', 'Hidden']], 
				prefManager.getCharPref('s4f.trends'))+
		   '</td><td colspan="2" class="s4f_td"></tr>';
		   
	cnt += '<tr><td class="s4f_td">Whois</td><td class="s4f_td">'+
			make_selector(
				's4f.whois', 
				[['show', 'Show'], ['hidden', 'Hidden']], 
				prefManager.getCharPref('s4f.whois'))+
		   '</td><td colspan="2" class="s4f_td"></tr>';
	
	cnt += '<tr style="height: 50px;">'+
		   '<td colspan="2" align="center">'+
		   '<input type="button" value="Save" onclick="Seo4Firefox.applyOptions()" '+
		   'style="font-weight: bold; padding-left: 20px; padding-right: 20px;" /></td>'+
		   '<td colspan="2" align="center">'+
		   '<input type="button" value="Cancel" onclick="Seo4Firefox.hideOptions()" '+
		   'style="padding-left: 20px; padding-right: 20px;" /></td></tr>';
	cnt += '</table>'

	var panel = document.createElement('DIV');
	panel.style = 'position: fixed; left: '+left+'px; top: '+top+'px; padding: 6px; '+
		' background: white; color: black; font-size: 13px; font-family: verdana; '+
		' border: 1px solid gray; width : '+panel_width+'px; height: '+panel_height+'px;';
	panel.id ='Seo4Firefox_options_panel';
	panel.innerHTML = cnt;  
	this.optionPanel = panel;    
	document.documentElement.appendChild(panel);
}

s.hideOptions = function(){
	if (this.optionPanel == null) return;
	this.optionPanel.style = 'display:none';
	this.optionPanel.parentNode.removeChild(this.optionPanel);
}

s.applyOptions = function() {
	var available_grabbers = this.available_grabbers;
	for (var i = 0; i < available_grabbers.length; i++){
		new_mode = document.getElementById(available_grabbers[i][0]).value;
		new_delay = document.getElementById(available_grabbers[i][0]+'.delay').value;
		
		//alert(available_grabbers[i][1]+' : '+new_mode + ', '+new_delay+' sec');
		prefManager.setPref(available_grabbers[i][0], new_mode);
		prefManager.setPref(available_grabbers[i][0]+'.delay', new_delay);
	}
	
	prefManager.setPref('s4f.highlight', document.getElementById('s4f.highlight').checked);
	prefManager.setPref('s4f.highlightColor', document.getElementById('s4f.highlightColor').value);
	
	prefManager.setPref('s4f.trends', document.getElementById('s4f.trends').value);
	prefManager.setPref('s4f.whois', document.getElementById('s4f.whois').value);
	
	prefManager.savePreferences();
	this.hideOptions();
}

s.toggleEnabled = function(){
	var enabled = !prefManager.getBoolPref('s4f.enabled');
	prefManager.setPref('s4f.enabled', enabled);
	alert('SEO for Opera is now '+(enabled?'enabled':'disabled')+'.');
	prefManager.savePreferences();
}

// Get the domain from a url
s.getDomain = function(url) {
  if (!url) return '';
  var temp = url.replace('http://','');
  temp = temp.replace('https://','');
  var temp = temp.split('/');
  return s.getTLD(temp[0]);
}

// Get the top-level domain from a fully-qualified domain name
s.getTLD = function(fqdn) {
  fqdn = fqdn.toLowerCase(); // force lowercase for parsing
  var labels = fqdn.split('.');
  if (labels.length >= 3) {
    var www = labels[0] == 'www'? 1 : 0;
    // assume that any domain having at least 3 labels ending with a 2 byte label, also contains a country code for its last two labels
    labels.splice(www, (labels.slice(-1).toString().length == 2? labels.length-3-www : labels.length-2-www)); // chop subdomains
  }
  return labels.join('.');
}

// ------------------------------------------------------------------------------------------------
// Delegate object
// ------------------------------------------------------------------------------------------------

function Delegate() {}
Delegate.create = function (o, f) {
  var a = new Array() ;
  var l = arguments.length ;
  for(var i = 2 ; i < l ; i++) a[i - 2] = arguments[i] ;
  return function() {
    var aP = [].concat(arguments, a) ;
    f.apply(o, aP);
  }
}

// ------------------------------------------------------------------------------------------------
// Handle Menu Clicks
// ------------------------------------------------------------------------------------------------

s.showLookup = function(url) {
  var win = window.openDialog("chrome://seo4firefox/content/lookup.xul","singleSeo", "chrome,centerscreen,resizable", url);
}

// ------------------------------------------------------------------------------------------------
// Handle Status click
// ------------------------------------------------------------------------------------------------
s.statusClick = function() {
  var enabled = prefManager.getBoolPref("extensions.s4f.enabled");
  prefManager.setBoolPref("extensions.s4f.enabled", !enabled);
  this.updateStatus();
}
s.updateStatus = function() {
  /*
  var enabled = prefManager.getBoolPref("extensions.s4f.enabled");
  if (enabled) {
    if (document.getElementById('seo4firefox-toggle-icon')) document.getElementById('seo4firefox-toggle-icon').src = "chrome://seo4firefox/content/status-enabled.png";
  } else {
    if (document.getElementById('seo4firefox-toggle-icon')) document.getElementById('seo4firefox-toggle-icon').src = "chrome://seo4firefox/content/status-disabled.png";
  }
  */
}

s.Log = function(s) {}

function s4f_StorageEngine(prefix, domain, getDataFunction)
{
  // Prefix used for recognition of the messages.
  this.msgPrefix = prefix;
  // Domain used for storing data in the cookies.
  this.domain = domain;
  // Function for obtaining stored data.
  // 1-st parameter - data string,
  // 2-nd parameter - identifier allowing to determine type of data.
  this.getDataFunction = getDataFunction;

  this.frameId = '';
  this.msgSave = '_s4f_storage_save';
  this.msgLoad = '_s4f_storage_load';
  this.msgDelete = '_s4f_storage_delete';
  this.msgSeparator = '\n';

  this.createFrame = function(id, onload)
  {
    if(!id)
    {
      alert('UserJS Storage: Incorrect call to the [createFrame] function. [id] parameter is not specified.');
      return;
    }

    if(!this.domain)
    {
      alert('UserJS Storage: [domain] property must be initialized before calling [createFrame] function.');
      return;
    }

    this.frameId = id;

    var f = document.createElement('IFRAME');
    f.src = 'http://' + this.domain;
    f.id = id;
    f.width = 0;
    f.height = 0;
    f.frameBorder = 'no';
    f.scrolling = 'no';
    if(onload)
      f.onload = onload;
    document.documentElement.appendChild(f);
  };
  
  this.postMessage = function(msg, doc, wnd)
    {
      try
      {
        doc.postMessage(msg);        
      }
      catch(err1)
      {
        try
        {
          wnd.postMessage(msg);
        }
        catch(err2){}
      }
    },

  this.sendMessageToFrame = function(msg)
  {
    var f = document.getElementById(this.frameId);
    if(f)
    {
      this.postMessage(msg, f.contentDocument, f.contentWindow);
    }
  };

  this.saveData = function(data, cookie)
  {
    if(!cookie)
    {
      alert('UserJS Storage: Incorrect call to the [saveData] function. [cookie] parameter is not specified.');
      return;
    }

    if(!this.msgPrefix)
    {
      alert('UserJS Storage: [msgPrefix] property must be initialized before calling [saveData] function.');
      return;
    }

    var msg = this.msgPrefix + this.msgSave + this.msgSeparator;
    msg += cookie + this.msgSeparator + encodeURIComponent(data);
    
    //alert('Sending message :\n'+msg);
    this.sendMessageToFrame(msg);
  };

  this.loadData = function(cookie, msgId)
  {
    if(!cookie)
    {
      alert('UserJS Storage: Incorrect call to the [loadData] function. [cookie] parameter is not specified.');
      return;
    }

    if(!msgId)
    {
      alert('UserJS Storage: Incorrect call to the [loadData] function. [msgId] parameter is not specified.');
      return;
    }

    if(!this.msgPrefix)
    {
      alert('UserJS Storage: [msgPrefix] property must be initialized before calling [loadData] function.');
      return;
    }

    if(!this.getDataFunction)
    {
      alert('UserJS Storage: [getDataFunction] property must be initialized before calling [loadData] function.');
      return;
    }

    var msg = this.msgPrefix + this.msgLoad + this.msgSeparator;
    msg += cookie + this.msgSeparator + msgId;
    this.sendMessageToFrame(msg);
  };

  this.deleteData = function(cookie)
  {
    if(!cookie)
    {
      alert('UserJS Storage: Incorrect call to the [deleteData] function. [cookie] parameter is not specified.');
      return;
    }

    if(!this.msgPrefix)
    {
      alert('UserJS Storage: [msgPrefix] property must be initialized before calling [deleteData] function.');
      return;
    }

    var msg = this.msgPrefix + this.msgDelete + this.msgSeparator;
    msg += cookie;
    this.sendMessageToFrame(msg);
  };

  this.processMessage = function(e)
  {
  	//alert('Processing message :\n'+e.data);
    if(e.data && (e.data.indexOf(this.msgPrefix) == 0))
    {
      var d = e.data.split(this.msgSeparator);

      if(e.domain == this.domain)
      {
        // process message from frame
        if(d[0] && d[0] == this.msgPrefix + this.msgLoad)
        {
          // load
          var id = '', data = null; //WSH : so that I know there was no data
          if(d[1])
            id = d[1];
          if(d[2])
            data = decodeURIComponent(d[2]);

          this.getDataFunction(data, id);
        }

        return true;
      }
      else if(d[0])
      {
        // process message to frame
        if(d[0] == this.msgPrefix + this.msgSave)
        {
          // save
          var cookie = '', data = '';
          if(d[1])
            cookie = d[1];
          else
            return true;

          if(d[2])
            data = d[2];

          expdate = new Date("November 22, 2025 00:00:00");
          this.setCookie(cookie, data, expdate);

          return true;
        }
        else if(d[0] == this.msgPrefix + this.msgLoad)
        {
          // load
          var cookie = '', id = '';
          if(d[1])
            cookie = d[1];
          else
            return true;

          if(d[2])
            id = d[2];

          var msg = this.msgPrefix + this.msgLoad + this.msgSeparator + id;
          var data = this.getCookie(cookie);
          if(data)
            msg += this.msgSeparator + data;

          e.source.postMessage(msg);

          return true;
        }
        else if(d[0] == this.msgPrefix + this.msgDelete)
        {
          if(d[1])
            this.deleteCookie(d[1]);

          return true;
        }
      }
    }

    return false;
  };
  
  this.setCookie = function(name, value, expires)
  {
  	value = value ? escape(value) : '';
	domain = this.domain ? this.domain : '';
	expires = expires ? expires.toGMTString() : '';
    
    setTimeout(function(){
		document.cookie = name + '=' + value + '; domain=' + domain + '; path=/; expires=' + expires;
	}, 10);
  };


  this.getCookie = function(name)
  {
    var prefix = name + '=';
    var i1 = document.cookie.indexOf(prefix);
    if (i1 == -1)
      return null;

    var i2 = document.cookie.indexOf(";", i1 + prefix.length);
    if (i2 == -1)
      i2 = document.cookie.length;

    var len = prefix.length;

    return unescape(document.cookie.substring(i1 + len, i2));
  };

  this.deleteCookie = function(name)
  {
	domain = this.domain ? this.domain : '';
    setTimeout(function(){document.cookie = name + '=; domain=' + domain + '; path=/; expires=' + new Date((new Date).getTime()-1e11).toGMTString();}, 10);
  };
}

// ------------------------------------------------------------------------------------------------
// Create an event listener for loaded documents
// ------------------------------------------------------------------------------------------------
window.addEventListener(
  "load",
  function () {
    //gBrowser.addEventListener("load", Seo4Firefox.checkLoad, true);
    
	//Determine if running inside a frame
	var bFrame = false;
    try
    {
      if(window.parent != window)
      {
        bFrame = true;
      }
    }
    catch(e)
    {
      bFrame = true;
    }
    if(!bFrame)
    {
		prefManager.storage.createFrame('s4f_storage_frame', function () {
			//Run the main script when preferences are loaded
			prefManager.onPrefsLoaded = function() {
	  			Seo4Firefox.checkLoad();
			}
			prefManager.loadPreferences();
	  		//Seo4Firefox.showOptions();
		});
    }
  },
  false
);

